//----------------------------------------------------------------------------
// rc6.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: rc6.pas
//----------------------------------------------------------------------------
#ifndef rc6HPP
#define rc6HPP
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <System.hpp>
namespace Rc6
{
//-- type declarations -------------------------------------------------------
struct TQuadWord
{
	
	union
	{
		Byte b[16];
		long w[4];
		
	};
} ;

typedef TQuadWord *PQuadWord;

typedef Byte TBlock[16];

struct TRC6_ctx
{
	bool Initialised;
	bool IVInitialised;
	Byte IV[16];
	Byte ct[16];
	long S[44];
	union
	{
		long LongBuffer[4];
		Byte ByteBuffer[16];
		
	};
} ;

typedef TBlock *PBlock;

enum TRegistered { NotRegistered, Registered };

enum TCipherMode { ECB, CBC, CFB, OFB };

enum TStringMode { smEncode, smNormal };

enum TKeySize { Small128, Med192, Large256 };

class __declspec(delphiclass) TRC6;
class __declspec(pascalimplementation) TRC6 : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	TRC6_ctx ctx;
	TCipherMode FCipherMode;
	TKeySize FKeySize;
	Byte FBuffer[4113];
	TBlock *PtrBuffer;
	TRegistered FRegistered;
	TStringMode FStringMode;
	virtual void __fastcall SetRegistered(TRegistered Value);
	void __fastcall rotl(long &x, const int y);
	void __fastcall rotr(long &x, const int y);
	void __fastcall rc6_key_setup(const Byte * K, const int K_Size, const int KeyLength);
	void __fastcall rc6_block_decrypt(const TQuadWord &ct, TQuadWord &pt);
	void __fastcall rc6_block_encrypt(const TQuadWord &pt, TQuadWord &ct);
	int __fastcall EncryptBuffer(int &Len);
	int __fastcall DecryptBuffer(int &Len);
	void __fastcall EncryptBlockMode(void);
	void __fastcall DecryptBlockMode(void);
	void __fastcall EncBlock(void);
	void __fastcall DecBlock(void);
	void __fastcall NagRegister(void);
	System::AnsiString __fastcall EncodeString( System::AnsiString InputString);
	System::AnsiString __fastcall DecodeString( System::AnsiString InputString);
	
public:
	int __fastcall InitialiseString(const System::AnsiString Key);
	int __fastcall InitialiseByte(const Byte * Key, const int Key_Size, int keylength);
	void __fastcall LoadIVString(const System::AnsiString IVString);
	void __fastcall LoadIVByte(const Byte * IVByte, const int IVByte_Size, int IVLength);
	int __fastcall EncryptString(const System::AnsiString Input,  System::AnsiString &Output);
	int __fastcall DecryptString(const System::AnsiString Input,  System::AnsiString &Output);
	int __fastcall EncryptBlock(const Byte * Input, Byte * Output);
	int __fastcall DecryptBlock(const Byte * Input, Byte * Output);
	int __fastcall EncryptFile(const System::AnsiString InputFileName,  System::AnsiString OutputFileName
		);
	int __fastcall DecryptFile(const System::AnsiString InputFileName,  System::AnsiString OutputFileName
		);
	void __fastcall Burn(void);
	System::AnsiString __fastcall GetVersion(void);
	
__published:
	__property TCipherMode CipherMode = {read=FCipherMode, write=FCipherMode, nodefault};
	__property TKeySize KeySize = {read=FKeySize, write=FKeySize, nodefault};
	__property TRegistered Registered = {read=FRegistered, write=SetRegistered, nodefault};
	__property TStringMode StringMode = {read=FStringMode, write=FStringMode, nodefault};
public:
	/* TComponent.Create */ __fastcall virtual TRC6(Classes::TComponent* AOwner) : Classes::TComponent(
		AOwner) { }
	/* TComponent.Destroy */ __fastcall virtual ~TRC6(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define OK (Byte)(0)
#define KEY_NOT_SET (Shortint)(-1)
#define ZERO_KEY_LENGTH (Shortint)(-2)
#define MSG_TOO_SHORT (Shortint)(-3)
#define IV_NOT_SET (Shortint)(-4)
#define FILE_ERROR (Shortint)(-5)
#define BLOCKSIZE (Byte)(16)
#define BUFFERLENGTH (Word)(4096)
#define r (Byte)(20)
#define R24 (Byte)(44)
extern void __fastcall Register(void);

}	/* namespace Rc6 */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Rc6;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// rc6
